#include "include/microSynth.h"

RtMidiIn *midiInMS = new RtMidiIn ("microSynth");
//RtMidiOut *midiOutMS = new RtMidiOut("microSynth");
static int noteC;

void midiCallback(double deltatime, std::vector<unsigned char> *message, void *userData)
{
  unsigned int nBytes = message->size();
  int fm = message->operator [](0);
  int sm = message->operator [](1);
  int tm = message->operator [](2);
  for ( unsigned int i=0; i<nBytes; i++ )
  {

      if (fm == 144) {
          synth->setControlVol(tm);
          noteC++;
      }


      if (fm == 128) {
          noteC--;
          if (noteC < 1) synth->setControlVol(0);
      }

      synth->setPitch(sm);


  }
}

void newMidi (RtMidiIn *midiIn/*, RtMidiOut *midiOut*/) {
    midiIn->setCallback(&midiCallback);

#ifndef _WIN32
    midiIn->openVirtualPort("microSynth MIDI In");
    //midiOut->openVirtualPort("microSynth MIDI Out");
#endif

#ifdef _WIN32
    midiIn->openPort("microSynth MIDI In");
    //midiOut->openPort("microSynth MIDI Out");
#endif

    midiIn->ignoreTypes(true, true, true);
}
